function OnPlayerRightClick(Player, BlockX, BlockY, BlockZ, BlockFace, CursorX, CursorY, CursorZ)
	World = Player:GetWorld()
	--Check for a sign
	if (BlockType == E_BLOCK_SIGN) then	
		Read, Line1, Line2, Line3, Line4 = World:GetSignLines( BlockX, BlockY, BlockZ)
		--If the sign is written correctly, it should now set gamemode
		if Line1 == "[GameMode]" then
			
			if (Line2 == "Survival" or Line2 == "survival" or Line2 == "0") and (Player:HasPermission("gmsign.use.survival"))  then
				Player:SendMessageSuccess('Gamemode set to Survival!')
				Player:SetGameMode(gmSurvival)
				return true
			elseif (Line2 == "Creative" or Line2 == "creative" or Line2 == "1") and (Player:HasPermission("gmsign.use.creative")) then
				Player:SendMessageSuccess('Gamemode set to Creative!')
				Player:SetGameMode(gmCreative)
				return true
			elseif (Line2 == "Adventure" or Line2 == "adventure" or Line2 == "2") and (Player:HasPermission("gmsign.use.adventure")) then
				Player:SendMessageSuccess('Gamemode set to Adventure!')
				Player:SetGameMode(gmAdventure)
				return true
			elseif (Line2 == "Spectator" or Line2 == "spectator" or Line2 == "3") and (Player:HasPermission("gmsign.use.spectator")) then
				Player:SendMessageSuccess('Gamemode set to Spectator!')
				Player:SetGameMode(gmSpectator)
				return true
			end
			
			Player:SendMessageFailure('Invalid sign type, or you lack permission to use a gamemode sign of this type.')
			return true
		end
		
	end
	
	return false
end

function OnUpdatingSign(World, BlockX, BlockY, BlockZ, Line1, Line2, Line3, Line4, Player)
	--Avoid creating of warp signs by non-allowed users
	if Line1 == "[GameMode]" then
		if (not(Player:HasPermission("gmsign.create") == true)) then
			Player:SendMessageFailure('You lack permission to create gamemode signs.')
			return true
		elseif (Line2 == "") then
			Player:SendMessageFailure('Must supply a tag for the gamemode (example: survival).')
			return true
		end
	end
	
	return false
end


